/*
    This file is part of FireBible, a bible study tool for Firefox.    
    Copyright (C) 2008 Brian Fernandes <infernalproteus@gmail.com>

    FireBible is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

package com.thegoan.firebible;

import java.net.URL;
import java.security.AllPermission;
import java.security.CodeSource;
import java.security.PermissionCollection;
import java.security.Policy;
import java.util.HashSet;


public class FBPolicy extends Policy {
	
	private Policy superPolicy;
	private HashSet goodURLSet = new HashSet();	
	
	public void setPolicyURL(Policy policy, URL[] urls) {
		superPolicy = policy;		
		for (int i = 0; i < urls.length; i++) {
			goodURLSet.add(urls[i].toExternalForm());			
		}
	}	
	
	public PermissionCollection getPermissions(CodeSource codesource) {
		PermissionCollection pc = superPolicy.getPermissions(codesource);
		URL url = codesource.getLocation();
		if (url != null && goodURLSet.contains(url.toExternalForm())) {
			pc.add(new AllPermission());
		}
		return pc;
	}

	public void refresh() {
		superPolicy.refresh();		
	}	

}
